# Class VulkanViewport.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanViewport.Builder

Enclosing class:
  `VulkanViewport`

public static final class VulkanViewport.Builder extends Object
Builds instances of type `VulkanViewport`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanViewport`
  `build()`
  Builds a new `VulkanViewport`.
  `final VulkanViewport.Builder`
  `from(VulkanViewportType instance)`
  Fill a builder with attribute values from the provided `VulkanViewportType` instance.
  `final VulkanViewport.Builder`
  `setHeight(float height)`
  Initializes the value for the `height` attribute.
  `final VulkanViewport.Builder`
  `setMaxDepth(float maxDepth)`
  Initializes the value for the `maxDepth` attribute.
  `final VulkanViewport.Builder`
  `setMinDepth(float minDepth)`
  Initializes the value for the `minDepth` attribute.
  `final VulkanViewport.Builder`
  `setWidth(float width)`
  Initializes the value for the `width` attribute.
  `final VulkanViewport.Builder`
  `setX(float x)`
  Initializes the value for the `x` attribute.
  `final VulkanViewport.Builder`
  `setY(float y)`
  Initializes the value for the `y` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanViewport.Builder from(VulkanViewportType instance)
    Fill a builder with attribute values from the provided `VulkanViewportType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final VulkanViewport.Builder setX(float x)
    Initializes the value for the `x` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `x`.

    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final VulkanViewport.Builder setY(float y)
    Initializes the value for the `y` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `y`.

    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setWidth

    public final VulkanViewport.Builder setWidth(float width)
    Initializes the value for the `width` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `width`.

    Parameters:
      `width` - The value for width
    Returns:
      `this` builder for use in a chained invocation

  - ### setHeight

    public final VulkanViewport.Builder setHeight(float height)
    Initializes the value for the `height` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `height`.

    Parameters:
      `height` - The value for height
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinDepth

    public final VulkanViewport.Builder setMinDepth(float minDepth)
    Initializes the value for the `minDepth` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `minDepth`.

    Parameters:
      `minDepth` - The value for minDepth
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaxDepth

    public final VulkanViewport.Builder setMaxDepth(float maxDepth)
    Initializes the value for the `maxDepth` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `maxDepth`.

    Parameters:
      `maxDepth` - The value for maxDepth
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanViewport build()
    Builds a new `VulkanViewport`.
    Returns:
      An immutable instance of VulkanViewport
    Throws:
      `IllegalStateException` - if any required attributes are missing